------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--                   P O L Y O R B . P O A _ C O N F I G                    --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--         Copyright (C) 2001-2012, Free Software Foundation, Inc.          --
--                                                                          --
-- This is free software;  you can redistribute it  and/or modify it  under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 3,  or (at your option) any later ver- --
-- sion.  This software is distributed in the hope  that it will be useful, --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.                                               --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
-- You should have received a copy of the GNU General Public License and    --
-- a copy of the GCC Runtime Library Exception along with this program;     --
-- see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    --
-- <http://www.gnu.org/licenses/>.                                          --
--                                                                          --
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

--  Global POA configuration

package body PolyORB.POA_Config is

   The_Configuration : Configuration_Access;

   -----------------------
   -- Set_Configuration --
   -----------------------

   procedure Set_Configuration (C : Configuration_Access) is
   begin
      pragma Assert (The_Configuration = null and then C /= null);

      The_Configuration := C;
   end Set_Configuration;

   -------------------
   -- Configuration --
   -------------------

   function Configuration return Configuration_Access is
   begin
      pragma Assert (The_Configuration /= null);

      return The_Configuration;
   end Configuration;

end PolyORB.POA_Config;
